Index: LMDZ5/branches/testing/libf/phylmd/cv3a_uncompress.F
===================================================================
--- LMDZ5/branches/testing/libf/phylmd/cv3a_uncompress.F	(revision 1707)
+++ LMDZ5/branches/testing/libf/phylmd/cv3a_uncompress.F	(revision 1750)
@@ -9,7 +9,10 @@
      :         ,Plim1,Plim2,asupmax,supmax0
      :         ,asupmaxmin
-!AC!
-     :         ,da,phi
-!AC!
+!
+     :         ,da,phi                               !AC!
+     :         ,mp,phi2,d1a,dam,sigij                  !RomP
+     :         ,wdtrainA,wdtrainM,elij,clw           !RomP
+     :         ,evap,ep                              !RomP
+!
      o         ,iflag1,kbas1,ktop1
      :         ,precip1,cbmf1,plcl1,plfc1,wbeff1,sig1,w01,ptop21
@@ -21,7 +24,10 @@
      :         ,Plim11,Plim21,asupmax1,supmax01
      :         ,asupmaxmin1     
-!AC!
-     :         ,da1,phi1  )
-!AC!
+!
+     o         ,da1,phi1                             !AC!
+     o         ,mp1,phi21,d1a1,dam1,sigij1             !RomP
+     o         ,wdtrainA1,wdtrainM1,elij1,clw1       !RomP
+     o         ,evap1,ep1)                           !RomP
+!
 ***************************************************************
 *                                                             *
@@ -56,7 +62,14 @@
       real asupmax(nloc,nd),supmax0(nloc)
       real asupmaxmin(nloc)
-!AC!
-      real da(nloc,nd),phi(nloc,nd,nd)
-!AC!
+!
+      real da(nloc,nd),phi(nloc,nd,nd)                    !AC!
+      real mp(nloc,nd)                                    !RomP
+      real phi2(nloc,nd,nd)                               !RomP
+      real d1a(nloc,nd),dam(nloc,nd)                      !RomP
+      real wdtrainA(nloc,nd), wdtrainM(nloc,nd)           !RomP
+      real sigij(nloc,nd,nd)                                !RomP
+      real elij(nloc,nd,nd),clw(nloc,nd)                  !RomP
+      real evap(nloc,nd),ep(nloc,nd)                      !RomP
+!
 c outputs:
       integer iflag1(len),kbas1(len),ktop1(len)
@@ -76,7 +89,14 @@
       real asupmax1(len,nd),supmax01(len)
       real asupmaxmin1(len)
-!AC!
-      real da1(nloc,nd),phi1(nloc,nd,nd)
-!AC!
+!
+      real da1(nloc,nd),phi1(nloc,nd,nd)                  !AC!
+      real mp1(nloc,nd)                                   !RomP
+      real phi21(nloc,nd,nd)                              !RomP
+      real d1a1(nloc,nd),dam1(nloc,nd)                    !RomP
+      real wdtrainA1(len,nd), wdtrainM1(len,nd)           !RomP
+      real sigij1(len,nd,nd)                                !RomP
+      real elij1(len,nd,nd),clw1(len,nd)                  !RomP
+      real evap1(len,nd),ep1(len,nd)                      !RomP
+!
 c
 c local variables:
@@ -122,7 +142,15 @@
             fqd1(idcum(i),k)=fqd(i,k)
             asupmax1(idcum(i),k)=asupmax(i,k)
-!AC!
-            da1(idcum(i),k)=da(i,k)
-!AC!
+!
+            da1(idcum(i),k)=da(i,k)                       !AC!
+            mp1(idcum(i),k)      = mp(i,k)                !RomP
+            d1a1(idcum(i),k)     = d1a(i,k)               !RomP
+            dam1(idcum(i),k)     = dam(i,k)               !RomP
+            wdtrainA1(idcum(i),k)= wdtrainA(i,k)          !RomP
+            wdtrainM1(idcum(i),k)= wdtrainM(i,k)          !RomP
+            clw1(idcum(i),k)     = clw(i,k)               !RomP
+            evap1(idcum(i),k)    = evap(i,k)              !RomP
+            ep1(idcum(i),k)      = ep(i,k)                !RomP
+!
  2010    continue
  2020   continue
@@ -143,8 +171,11 @@
 
 !AC!
-       do j=1,nd
-         do k=1,nd 
+       do k2=1,nd
+         do k1=1,nd 
           do i=1,ncum
-            phi1(idcum(i),k,j)=phi(i,k,j)
+            phi1(idcum(i),k1,k2)=phi(i,k1,k2)                 !AC!
+            phi21(idcum(i),k1,k2)= phi2(idcum(i),k1,k2)   !RomP
+            sigij1(idcum(i),k1,k2) = sigij(idcum(i),k1,k2)    !RomP
+            elij1(idcum(i),k1,k2)= elij(idcum(i),k1,k2)   !RomP
           end do
          end do
@@ -157,5 +188,5 @@
 c          do 2200 i=1,ncum
 c            ment1(idcum(i),k1,k2) = ment(i,k1,k2)
-c            sij1(idcum(i),k1,k2) = sij(i,k1,k2)
+c            sigij1(idcum(i),k1,k2) = sigij(i,k1,k2)
 c2200      enddo
 c2210     enddo
Index: LMDZ5/branches/testing/libf/phylmd/cv3p_mixing.F
===================================================================
--- LMDZ5/branches/testing/libf/phylmd/cv3p_mixing.F	(revision 1707)
+++ LMDZ5/branches/testing/libf/phylmd/cv3p_mixing.F	(revision 1750)
@@ -3,5 +3,5 @@
      :                    ,unk,vnk,hp,tv,tvp,ep,clw,sig
      :                    ,ment,qent,hent,uent,vent,nent
-     :                   ,sij,elij,supmax,ments,qents,traent)
+     :                   ,sigij,elij,supmax,ments,qents,traent)
 ***************************************************************
 *                                                             *
@@ -36,10 +36,9 @@
       real ment(nloc,na,na), qent(nloc,na,na)
       real uent(nloc,na,na), vent(nloc,na,na)
-      real sij(nloc,na,na), elij(nloc,na,na)
+      real sigij(nloc,na,na), elij(nloc,na,na)
       real supmax(nloc,na)     ! Highest mixing fraction of mixed updraughts
                                ! with the sign of (h-hp)
       real traent(nloc,nd,nd,ntra)
       real ments(nloc,nd,nd), qents(nloc,nd,nd)
-      real sigij(nloc,nd,nd)
       real hent(nloc,nd,nd)
       integer nent(nloc,nd)
@@ -57,4 +56,5 @@
       real Sbef(nloc), Sup(nloc), Smin(nloc)
       real asij(nloc), smax(nloc), scrit(nloc)
+      real sij(nloc,nd,nd)
       real csum(nloc,nd)
       real awat
Index: LMDZ5/branches/testing/libf/phylmd/cv_driver.F
===================================================================
--- LMDZ5/branches/testing/libf/phylmd/cv_driver.F	(revision 1707)
+++ LMDZ5/branches/testing/libf/phylmd/cv_driver.F	(revision 1750)
@@ -9,5 +9,7 @@
      &                   icb1,inb1,
      &                   delt,Ma1,upwd1,dnwd1,dnwd01,qcondc1,wd1,cape1,
-     &                   da1,phi1,mp1)
+     &                   da1,phi1,mp1,phi21,d1a1,dam1,sij1,clw1,elij1,
+     &                   evap1,ep1,epmlmMm1,eplaMm1,
+     &                   wdtrainA1,wdtrainM1)
 C
       USE dimphy
@@ -67,5 +69,6 @@
 cym#include "dimensions.h"
 cym#include "dimphy.h"
-
+c
+c Input
       integer len
       integer nd
@@ -74,4 +77,5 @@
       integer iflag_con
       integer ntra
+      real delt
       real t1(len,nd)
       real q1(len,nd)
@@ -79,6 +83,9 @@
       real u1(len,nd)
       real v1(len,nd)
+      real tra1(len,nd,ntra)
       real p1(len,nd)
       real ph1(len,ndp1)
+c
+c Output
       integer iflag1(len)
       real ft1(len,nd)
@@ -86,7 +93,12 @@
       real fu1(len,nd)
       real fv1(len,nd)
+      real ftra1(len,nd,ntra)
       real precip1(len)
       real cbmf1(len)
-      real VPrecip1(len,nd+1)
+      real sig1(klon,klev)
+      real w01(klon,klev)
+      real VPrecip1(len,nd+1) 
+      real evap1(len,nd)                    !RomP
+      real ep1(len,nd)                      !RomP
       real Ma1(len,nd)
       real upwd1(len,nd)
@@ -98,10 +110,14 @@
       real cape1(len)     
 
+! RomP >>> 
+      real wdtrainA1(len,nd), wdtrainM1(len,nd)
+      real sij1(len,nd,nd),elij1(len,nd,nd)
       real da1(len,nd),phi1(len,nd,nd),mp1(len,nd)
-      real da(len,nd),phi(len,nd,nd),mp(len,nd)
-      real tra1(len,nd,ntra)
-      real ftra1(len,nd,ntra)
-
-      real delt
+
+      real phi21(len,nd,nd)
+      real d1a1(len,nd), dam1(len,nd)
+      real epmlmMm1(len,nd,nd),eplaMm1(len,nd)
+! RomP <<<
+
 
 !-------------------------------------------------------------------
@@ -243,6 +259,4 @@
       real tvp1(klon,klev)
       real clw1(klon,klev)
-      real sig1(klon,klev)
-      real w01(klon,klev)
       real th1(klon,klev)
 c
@@ -277,4 +291,12 @@
       real ments(nloc,klev,klev), qents(nloc,klev,klev)
       real sij(nloc,klev,klev), elij(nloc,klev,klev)
+! RomP >>>
+      real da(nloc,klev),phi(nloc,klev,klev),mp(nloc,klev)
+      real epmlmMm(nloc,klev,klev),eplaMm(nloc,klev)  
+      real phi2(nloc,klev,klev)
+      real d1a(nloc,klev), dam(nloc,klev)
+      real wdtrainA(nloc,klev),wdtrainM(nloc,klev)
+      real sigd(nloc)
+! RomP <<<
       real qp(nloc,klev), up(nloc,klev), vp(nloc,klev)
       real wt(nloc,klev), water(nloc,klev), evap(nloc,klev)
@@ -295,5 +317,5 @@
 ! --- SET CONSTANTS AND PARAMETERS
 !-------------------------------------------------------------------
-
+      print *, '-> cv_driver'      !jyg
 c -- set simulation flags:
 c   (common cvflag)
@@ -325,40 +347,30 @@
 !---------------------------------------------------------------------
 
-      do 20 k=1,nd
-        do 10 i=1,len
-         ft1(i,k)=0.0
-         fq1(i,k)=0.0
-         fu1(i,k)=0.0
-         fv1(i,k)=0.0
-         tvp1(i,k)=0.0
-         tp1(i,k)=0.0
-         clw1(i,k)=0.0
+         ft1(:,:)=0.0
+         fq1(:,:)=0.0
+         fu1(:,:)=0.0
+         fv1(:,:)=0.0
+         tvp1(:,:)=0.0
+         tp1(:,:)=0.0
+         clw1(:,:)=0.0
 cym
-         clw(i,k)=0.0	 
-         gz1(i,k) = 0.
-         VPrecip1(i,k) = 0.
-         Ma1(i,k)=0.0
-         upwd1(i,k)=0.0
-         dnwd1(i,k)=0.0
-         dnwd01(i,k)=0.0
-         qcondc1(i,k)=0.0
- 10     continue
- 20   continue
-
-      do 30 j=1,ntra
-       do 31 k=1,nd
-        do 32 i=1,len
-         ftra1(i,k,j)=0.0
- 32     continue    
- 31    continue    
- 30   continue    
-
-      do 60 i=1,len
-        precip1(i)=0.0
-        iflag1(i)=0
-        wd1(i)=0.0
-        cape1(i)=0.0
-        VPrecip1(i,nd+1)=0.0
- 60   continue
+         clw(:,:)=0.0	 
+         gz1(:,:) = 0.
+         VPrecip1(:,:) = 0.
+         Ma1(:,:)=0.0
+         upwd1(:,:)=0.0
+         dnwd1(:,:)=0.0
+         dnwd01(:,:)=0.0
+         qcondc1(:,:)=0.0
+
+         ftra1(:,:,:)=0.0
+
+        elij1(:,:,:) = 0.0
+        sij1(:,:,:) = 0.0
+
+        precip1(:)=0.0
+        iflag1(:)=0
+        wd1(:)=0.0
+        cape1(:)=0.0
 
       if (iflag_con.eq.30) then
@@ -441,5 +453,5 @@
  400  continue
 
-c       print*,'klon, ncum = ',len,ncum
+         print*,'cv_driver : klon, ncum = ',len,ncum
 
       IF (ncum.gt.0) THEN
@@ -541,9 +553,12 @@
 
       if (iflag_con.eq.30) then
-       CALL cv30_unsat(nloc,ncum,nd,nd,ntra,icb,inb    ! na->nd
+!RomP >>>
+       CALL cv30_unsat(nloc,ncum,nd,nd,ntra,icb,inb         ! na->nd
      :               ,t,q,qs,gz,u,v,tra,p,ph
      :               ,th,tv,lv,cpn,ep,sigp,clw
      :               ,m,ment,elij,delt,plcl
-     o          ,mp,qp,up,vp,trap,wt,water,evap,b)
+     :          ,mp,qp,up,vp,trap,wt,water,evap,b
+     o          ,wdtrainA,wdtrainM)
+!RomP <<<
       endif
 
@@ -588,6 +603,10 @@
 
       if (iflag_con.eq.30) then
+!RomP >>>
        CALL cv30_tracer(nloc,len,ncum,nd,nd,
-     :                  ment,sij,da,phi)
+     :                  ment,sij,da,phi,phi2,d1a,dam,
+     :                  ep,VPrecip,elij,clw,epmlmMm,eplaMm,
+     :                  icb,inb)
+!RomP <<<
       endif
 
@@ -603,15 +622,19 @@
        CALL cv30_uncompress(nloc,len,ncum,nd,ntra,idcum
      :          ,iflag
-     :          ,precip,VPrecip,sig,w0
+     :          ,precip,VPrecip,evap,ep,sig,w0        !RomP 
      :          ,ft,fq,fu,fv,ftra
-     :          ,inb 
+     :          ,inb
      :          ,Ma,upwd,dnwd,dnwd0,qcondc,wd,cape
-     :          ,da,phi,mp
+     :          ,da,phi,mp,phi2,d1a,dam,sij           !RomP
+     :          ,elij,clw,epmlmMm,eplaMm              !RomP  
+     :          ,wdtrainA,wdtrainM                    !RomP
      o          ,iflag1
-     o          ,precip1,VPrecip1,sig1,w01
+     o          ,precip1,VPrecip1,evap1,ep1,sig1,w01     !RomP
      o          ,ft1,fq1,fu1,fv1,ftra1
      o          ,inb1
      o          ,Ma1,upwd1,dnwd1,dnwd01,qcondc1,wd1,cape1 
-     o          ,da1,phi1,mp1)
+     o          ,da1,phi1,mp1,phi21,d1a1,dam1,sij1       !RomP
+     o          ,elij1,clw1,epmlmMm1,eplaMm1             !RomP 
+     o          ,wdtrainA1,wdtrainM1)                    !RomP 
       endif
 
@@ -632,4 +655,5 @@
 9999  continue
 
+      print *, 'fin cv_driver ->'      !jyg
       return
       end
Index: LMDZ5/branches/testing/libf/phylmd/cva_driver.F
===================================================================
--- LMDZ5/branches/testing/libf/phylmd/cva_driver.F	(revision 1707)
+++ LMDZ5/branches/testing/libf/phylmd/cva_driver.F	(revision 1750)
@@ -21,7 +21,7 @@
      &                   Plim11,Plim21,asupmax1,supmax01,asupmaxmin1
      &                   ,lalim_conv, 
-!AC!
-     &                   da1,phi1)
-!AC!
+     &                   da1,phi1,mp1,phi21,d1a1,dam1,sigij1,clw1,     ! RomP
+     &                   elij1,evap1,ep1,                              ! RomP 
+     &                   wdtrainA1,wdtrainM1)                          ! RomP
 ***************************************************************
 *                                                             *
@@ -175,6 +175,6 @@
 c
 !AC!
-      real da1(len,nd),phi1(len,nd,nd)
-      real da(len,nd),phi(len,nd,nd)
+!!      real da1(len,nd),phi1(len,nd,nd)
+!!      real da(len,nd),phi(len,nd,nd)
 !AC!
       real ftd1(len,nd)
@@ -186,4 +186,16 @@
       real asupmaxmin1(len)
       integer lalim_conv(len)
+! RomP >>> 
+      real wdtrainA1(len,nd), wdtrainM1(len,nd)
+      real wdtrainA(nloc,klev),wdtrainM(nloc,klev)
+      real da1(len,nd),phi1(len,nd,nd),mp1(len,nd)
+      real da(len,nd),phi(len,nd,nd)
+      real evap1(len,nd),ep1(len,nd)
+      real sigij1(len,nd,nd),elij1(len,nd,nd)
+      real phi2(len,nd,nd)
+      real d1a(len,nd), dam(len,nd)
+      real phi21(len,nd,nd)
+      real d1a1(len,nd), dam1(len,nd)
+! RomP <<<
 !-------------------------------------------------------------------
 ! --- ARGUMENTS
@@ -397,5 +409,5 @@
       real cin(nloc)
       real m(nloc,klev)
-      real ment(nloc,klev,klev), sij(nloc,klev,klev)
+      real ment(nloc,klev,klev), sigij(nloc,klev,klev)
       real qent(nloc,klev,klev)
       real hent(nloc,klev,klev)
@@ -505,5 +517,5 @@
       call  zilch(cbmf1   ,nword1)
       call  zilch(ptop21  ,nword1)
-      sigd1=0.
+      sigd1(:)=0.
       call  zilch(Ma1     ,nword2)
       call  zilch(mip1    ,nword2)
@@ -771,5 +783,5 @@
      :                       ,unk,vnk,hp,tv,tvp,ep,clw,sig
      :                    ,ment,qent,hent,uent,vent,nent
-     :                   ,sij,elij,supmax,ments,qents,traent)
+     :                   ,sigij,elij,supmax,ments,qents,traent)
 !        print*, 'cv3p_mixing-> supmax ', (supmax(1,k), k=1,nd)
       
@@ -828,5 +840,5 @@
      :                       ,ph,t,q,qs,u,v,tra,h,lv,qnk
      :                       ,unk,vnk,hp,tv,tvp,ep,clw,m,sig
-     o   ,ment,qent,uent,vent,nent,sij,elij,ments,qents,traent)
+     o   ,ment,qent,uent,vent,nent,sigij,elij,ments,qents,traent)
          CALL zilch(hent,nloc*klev*klev)
         ELSE
@@ -842,5 +854,5 @@
      :                     ,ph,t,q,qs,u,v,h,lv,qnk
      :                     ,hp,tv,tvp,ep,clw,cbmf
-     o                     ,m,ment,qent,uent,vent,nent,sij,elij)
+     o                     ,m,ment,qent,uent,vent,nent,sigij,elij)
       endif
 c
@@ -865,5 +877,6 @@
      :               ,ep,sigp,clw
      :               ,m,ment,elij,delt,plcl,coef_clos
-     o          ,mp,qp,up,vp,trap,wt,water,evap,b,sigd)
+     o          ,mp,qp,up,vp,trap,wt,water,evap,b,sigd
+     o          ,wdtrainA,wdtrainM)   ! RomP
       endif
      
@@ -925,6 +938,9 @@
 
       if (iflag_con.eq.3) then
+!RomP >>>
        CALL cv3_tracer(nloc,len,ncum,nd,nd,
-     :                  ment,sij,da,phi)
+     :                  ment,sigij,da,phi,phi2,d1a,dam,
+     :                  ep,Vprecip,elij,clw,icb,inb)
+!RomP <<<
       endif
 
@@ -947,7 +963,7 @@
      :          ,Plim1,Plim2,asupmax,supmax0
      :          ,asupmaxmin
-!AC!
-     :          ,da,phi
-!AC!
+     :          ,da,phi,mp,phi2,d1a,dam,sigij         ! RomP
+     :          ,wdtrainA,wdtrainM,elij,clw           ! RomP
+     :          ,evap,ep                              ! RomP
      o          ,iflag1,kbas1,ktop1
      o          ,precip1,cbmf1,plcl1,plfc1,wbeff1,sig1,w01,ptop21
@@ -959,7 +975,7 @@
      o          ,Plim11,Plim21,asupmax1,supmax01
      o          ,asupmaxmin1
-!AC!
-     o          ,da1,phi1)
-!AC!
+     o          ,da1,phi1,mp1,phi21,d1a1,dam1,sigij1  ! RomP
+     o          ,wdtrainA1,wdtrainM1,elij1,clw1       ! RomP
+     o          ,evap1,ep1)                           ! RomP
       endif
 
